' ============================================================================
' TweakersNews.vbs v1.01                                              - Lasoul
'
' Version history
' 1.00 Initial release
' 1.01 Small bugfix for incorrectly showing message: Site format has changed
' 1.10 Bugfix for incorrect generating an URL. some people got the error
'      OLE error 800c0005, which has been fixed now
'
' Mail: vorgers@planet.nl
' ============================================================================
'
' Retrieves News headlines from http://www.tweakers.net (Dutch site)
'
' ======
' USAGE:
' ======

' 1) Copy TweakersNews.vbs to your Samurize/scripts folder

' 2) Add an ActiveScript meter to your Samurize config with this script
'    selected and 'GenerateNewsList' selected as the Function.

' 3) Use TextFile meters to view the News items
'    If you don't use links than it is possible to show the contens of the
'    textfile with one control otherwise you have to make a control per line
'    (I think :-)

' ============================================================================
' USER SETTINGS
' ============================================================================

SHOW_NEWSTIMES = True      ' set to False if you don't want the news times displayed
USE_LINKS = True        ' set to False if you don't want links enabled

' ============================================================================

FILE_NAME = "TweakersNews.tmp"

Function GenerateNewsList()
            Dim fs, f, strHTMLResult, strTextToWrite

            strHTMLResult = ReturnHTML("http://www.tweakers.net/")
            If InStr(strHTMLResult, "<title>Tweakers.net") = 0 Then
                        strTextToWrite = "Site format has changed." & vbCrlf & "Script has failed."
            Else 
                        strTextToWrite = GetHeadLines(strHTMLResult)
            End If

            set fs = CreateObject("Scripting.FileSystemObject")
            set f = fs.CreateTextFile(FILE_NAME,true)
            f.write(strTextToWrite)
            f.close
            set f=nothing
            set fs=nothing
End Function

Private Function GetHeadLines(htmlResult)
            Dim intHeadLineStartPos, intHeadLineEndPos, strHeadLinesInfo, strHeadLineInfo, arrSplitHeadLineInfo, strNewsTxt

            ' First cut everything before the first headline fp_3(
            intHeadLineStartPos = InStr(htmlResult, "fp_3(")
            strHeadLinesInfo = htmlResult
            While intHeadLineStartPos >0 
                        strHeadLinesInfo = Mid(strHeadLinesInfo, intHeadLineStartPos+5)
                        intHeadLineEndPos = InStr(strHeadLinesInfo, ");")
                        strHeadLineInfo = Mid(strHeadLinesInfo, 1, intHeadLineEndPos-1)
                        arrSplitHeadLineInfo = Split(strHeadLineInfo, ",'")

                        ' Add the time
                        If SHOW_NEWSTIMES = TRUE Then
                                    GetHeadLines = GetHeadLines & Replace(arrSplitHeadLineInfo(1), "'", "") & " "
                        End If

                        ' Add the newstext
			strNewsTxt = Replace(Replace(Replace(arrSplitHeadLineInfo(3), "\'", "\@"), "'", ""), "\@", "'")
			'strNewsTxt = Replace(strNewsTxt, "\"", "\"")
                        GetHeadLines = GetHeadLines & strNewsTxt

                        ' Add the link
                        If USE_LINKS = TRUE Then
	                            GetHeadLines = GetHeadLines & "%lhttp://www.tweakers.net/nieuws/" & Replace(arrSplitHeadLineInfo(2), "'", "")
                        End If

                        ' Add a return
                        GetHeadLines = GetHeadLines & vbCrlf 

                        intHeadLineStartPos = InStr(intHeadLineEndPos+2, strHeadLinesInfo, "fp_3(")
            Wend
End Function

 

 

Private Function ReturnHTML(sURL)
            Dim objXMLHTTP,HTML

            Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
            objXMLHTTP.Open "GET", sURL, False
            objXMLHTTP.Send
            HTML = objXMLHTTP.responseBody
            Set objRS = CreateObject("ADODB.Recordset")
            objRS.Fields.Append "txt", 200, 45000, &H00000080
            objRS.Open
            objRS.AddNew
            objRS.Fields("txt").AppendChunk HTML
            ReturnHTML = objRS("txt").Value
            objRS.Close
            Set objRS = Nothing
            Set objXMLHTTP = Nothing
End Function
